//-------------------------  1994 by James G. Stout -------------------------------
// File		: colorCDEF.c
// Date		: March 14, 1994
// Author	: Jim Stout
// Purpose	: Color support routines for CDEF's
//----------------------------------------------------------------------------------
#include "colorCDEF.h"

//==================================================================================
//	Set an RGBColor for a control part - DOES NOT CHECK FOR COLOR SUPPORT
//==================================================================================
void setPartColor(ControlHandle theControl, short part, Boolean fore)
{
	short			inx;
	AuxCtlHandle	aux;
	CCTabHandle		ccTab;
	
	GetAuxCtl(theControl, &aux);
	if(aux) {
		ccTab = (**aux).acCTable;
		for(inx=0;inx<=(**ccTab).ctSize;inx++) {
			if((**ccTab).ctTable[inx].value == part) {
				if(fore)
					RGBForeColor(&(**ccTab).ctTable[inx].rgb);
				else
					RGBBackColor(&(**ccTab).ctTable[inx].rgb);
				break;
			}
		}
	}
}

//==================================================================================
//	Get RGBColor for foreground and background - DOES NOT CHECK FOR COLOR SUPPORT
//==================================================================================
void saveColors(RGBColor * saveFore, RGBColor * saveBack)
{
	GetForeColor(saveFore);
	GetBackColor(saveBack);
}

//==================================================================================
//	Set RGBColor for foreground and background - DOES NOT CHECK FOR COLOR SUPPORT
//==================================================================================
void restoreColors(RGBColor * saveFore, RGBColor * saveBack)
{
	RGBForeColor(saveFore);
	RGBBackColor(saveBack);
}