//----------------------------------------------------------------------------------
//	File		: dialogAssist.h
//	Date		: April 4, 1994
//	Author		: Jim Stout
//	Purpose		: Dialog utilities
//----------------------------------------------------------------------------------

#define DIDEVENT 1

#define MAKELONG(type, data)	((long)(((short)(type))) | (((long)((short)(data)) << 16)))

// Control dimming 

#define ON 1
#define OFF 0
#define NOTDIM 0
#define DIM 255

// Keys

#define		_HOME		01
#define		_END		04
#define		_ENTRKEY	03
#define		_BACK		8
#define		_TAB		9
#define		_PAGEUP		11
#define		_PAGEDOWN	12
#define		_RETURNKEY	13
#define		_ESCAPEKEY	27
#define		_LEFT		28
#define		_RIGHT		29
#define		_UP			30
#define		_DOWN		31
#define		_PLUS		43
#define		_MINUS		45
#define		_PERIODKEY	46
#define		_ZERO		48
#define		_NINE		57
#define		_DELKEY		127

#pragma mark _ControlRoutines

void			daToggleCheck		(DialogPtr d, short i);
void			daToggleRadio		(DialogPtr d, short i, short first, short last);
short			daGetRadio			(DialogPtr d, short first, short last);
void			daToggleCtl			(DialogPtr d, short i);
ControlHandle	daGetCtlHandle		(DialogPtr d, short i);
short			daGetCtlMax			(DialogPtr d, short i);
short			daGetCtlMin			(DialogPtr d, short i);
short			daGetCtlValue		(DialogPtr d, short i);
void			daSetCtlValue		(DialogPtr d, short i, short newVal);
void 			daGetCtlTitle 		(DialogPtr d, short i, Str255 theTitle);
void			daSetCtlTitle		(DialogPtr d, short i, Str255 newTitle);
long			daGetCtlRefCon		(DialogPtr d, short i);
void 			daSetCtlRefCon		(DialogPtr d, short i, long theValue);
void			daGetCtlRect		(DialogPtr d, short i, Rect *r);
void 			daSetCtlRect		(DialogPtr d, short i, Rect * newRect);
Boolean 		daIsHidden			(DialogPtr d, short i);

#pragma mark _MouseRoutines

short	daMouseWhere		(DialogPtr d, EventRecord * theEvt);
Boolean daMouseInItem	 	(DialogPtr d, short i, EventRecord * theEvt);
void	daEditCursor		(DialogPtr d);

#pragma mark _TextRoutines

void	daSetIText			(DialogPtr d, short i, Str255 newText);
void	daGetIText			(DialogPtr d, short i, Str255 getText);
void	daSetINum			(DialogPtr d, short i, long newNum);
long	daGetINum			(DialogPtr d, short i);
void	daSelIText			(DialogPtr d, short i);
void 	daSetInsert			(DialogPtr d, short i, short before);

#pragma mark _DefaultButton

void 	daSetDefItem		(DialogPtr d, short defItem);
void 	daDrawDefault 		(DialogPtr d);

#pragma mark _KeyRoutines

Boolean	daShiftSelect		(DialogPtr d, char key);
Boolean daOptionDown		(void);
Boolean daCmdDown			(void);
Boolean daCntlDown			(void);
Boolean daExitKey			(DialogPtr d, EventRecord *evt, short *i, short cancelItem);

Boolean daEnterNumber		(DialogPtr d, short i, long min, long max, char key);
Boolean daEnterPassword		(DialogPtr d, short i, short len, char key, Str255 pw);
Boolean daLimitText			(DialogPtr d, short i, short len, char key);
Boolean	daForwardDel		(DialogPtr d, char key);
Boolean daTEkey				(char key);

#pragma mark _DrawRoutines

void 	daSetIDraw			(DialogPtr d, short i, ProcPtr drawIt);
pascal void daDrawIFrame	(DialogPtr d, short i);

#pragma mark _ItemDimming

Boolean	daGetDim			(DialogPtr d, short item);
void	daDimItems			(DialogPtr d, short first, short last, Boolean dim);
void	daDimOne			(DialogPtr d, short i, Boolean dim);

#pragma mark _UtilityRoutines

long	daGestalt			(OSType selector);
Boolean daHasFeature		(OSType selector, short bitToCheck);

extern Boolean		trapAvailable	(short trapNum);
static short		numToolBoxTraps	(void);
static TrapType		getTrapType		(short trapType);

void	pStrCat				(char * p1, char * p2);
void	pStrCopy			(char * source, char * dest);
void	centerDialog		(DialogPtr d);